diff --git a/Config.in.legacy b/Config.in.legacy
index 5233785209..399e916a4f 100644
--- a/Config.in.legacy
+++ b/Config.in.legacy
@@ -146,6 +146,13 @@ endif
 
 comment "Legacy options removed in 2021.08"
 
+BR2_PACKAGE_LIBSOIL
+	bool "libsoil package removed"
+	select BR2_LEGACY
+	help
+	  The libsoil package was removed. All packages needing
+	  libsoil removed the dependency.
+
 config BR2_PACKAGE_CLAPACK
 	bool "cblas/clapack package removed"
 	select BR2_LEGACY
diff --git a/DEVELOPERS b/DEVELOPERS
index adfcc96059..114e133e94 100644
--- a/DEVELOPERS
+++ b/DEVELOPERS
@@ -387,7 +387,6 @@ F:	package/libpng/
 F:	package/libsidplay2/
 F:	package/libsilk/
 F:	package/libsndfile/
-F:	package/libsoil/
 F:	package/libsoundtouch/
 F:	package/libsquish/
 F:	package/libudfread/
diff --git a/package/Config.in b/package/Config.in
index 5066690a81..09cac91fb0 100644
--- a/package/Config.in
+++ b/package/Config.in
@@ -1512,7 +1512,6 @@ menu "Graphics"
 	source "package/libqrencode/Config.in"
 	source "package/libraw/Config.in"
 	source "package/librsvg/Config.in"
-	source "package/libsoil/Config.in"
 	source "package/libsvg/Config.in"
 	source "package/libsvg-cairo/Config.in"
 	source "package/libsvgtiny/Config.in"
diff --git a/package/libsoil/0001-fix-makefile.patch b/package/libsoil/0001-fix-makefile.patch
deleted file mode 100644
index 310d26448b..0000000000
--- a/package/libsoil/0001-fix-makefile.patch
+++ /dev/null
@@ -1,40 +0,0 @@
-Various makefile fixes to allow cross compilation
-
-Partly ported from
-http://anonscm.debian.org/cgit/pkg-games/libsoil.git/tree/debian/patches/linking_correctly.patch
-
-Signed-off-by: Bernd Kuhls <bernd.kuhls@t-online.de>
-
-diff -uNr soil.org/projects/makefile/alternate_Makefile.txt soil/projects/makefile/alternate_Makefile.txt
---- soil.org/projects/makefile/alternate_Makefile.txt	2008-07-07 18:13:28.000000000 +0200
-+++ soil/projects/makefile/alternate_Makefile.txt	2015-11-07 11:15:04.140106336 +0100
-@@ -1,8 +1,8 @@
- MAKE = make
--CC = gcc
--INSTALL_FILE = install -p -o root -g root -m 644
--INSTALL_DIR = install -p -o root -g root -d
--LN = ln -s
-+CC = $(GCC)
-+INSTALL_FILE = $(INSTALL) -m 644
-+INSTALL_DIR = $(INSTALL) -d
-+LN = ln -sf
- RM = rm -fv
- CFLAGS += -c -O2 -Wall
- LDFLAGS +=
-@@ -23,13 +23,13 @@
- all: $(OFILES) lib
- 
- %.o: %.c
--	$(CC) $(CFLAGS) $< -o $@
-+	$(CC) $(CFLAGS) -c -fPIC $< -o $@
- 
- lib: $(OFILES)
- 	# create static library
--	ar -cvq $(LIBNAME).a $(OFILES)
-+	$(AR) -cvq $(LIBNAME).a $(OFILES)
- 	# create shared library
--	gcc -shared -Wl,-soname,$(LIBNAME).so.$(MAJOR) -o $(LIBNAME).so.$(VERSION) $(OFILES)
-+	$(CC) -shared -Wl,-soname,$(LIBNAME).so.$(MAJOR) -o $(LIBNAME).so.$(VERSION) $(OFILES) -lGL -lm
- 
- install:
- 	$(INSTALL_DIR) $(DESTDIR)/$(INCLUDEDIR)
diff --git a/package/libsoil/Config.in b/package/libsoil/Config.in
deleted file mode 100644
index aea0cc3548..0000000000
--- a/package/libsoil/Config.in
+++ /dev/null
@@ -1,12 +0,0 @@
-config BR2_PACKAGE_LIBSOIL
-	bool "libsoil"
-	depends on BR2_PACKAGE_HAS_LIBGL
-	depends on !BR2_STATIC_LIBS
-	help
-	  SOIL is a tiny C library used primarily for uploading
-	  textures into OpenGL.
-
-	  http://www.lonesock.net/soil.html
-
-comment "libsoil needs an OpenGL backend and a toolchain w/ dynamic library"
-	depends on !BR2_PACKAGE_HAS_LIBGL || BR2_STATIC_LIBS
diff --git a/package/libsoil/libsoil.hash b/package/libsoil/libsoil.hash
deleted file mode 100644
index 2596cd6b4d..0000000000
--- a/package/libsoil/libsoil.hash
+++ /dev/null
@@ -1,4 +0,0 @@
-# Locally calculated
-sha256  a2305b8d64f6d636e36d669bbdb0ca5445d1345c754b3d61d3f037dad2e5f701  soil.zip
-sha256  a53f0508cafb544aa0b11c241c1000055bd9d827d19712f4de08898e36f29728  src/stb_image_aug.c
-sha256  449ba815b6f610660515246d029f5d08b45178fe8f9f9f520939edad85a7935e  src/image_helper.c
diff --git a/package/libsoil/libsoil.mk b/package/libsoil/libsoil.mk
deleted file mode 100644
index 2945edd8dd..0000000000
--- a/package/libsoil/libsoil.mk
+++ /dev/null
@@ -1,50 +0,0 @@
-################################################################################
-#
-# libsoil
-#
-################################################################################
-
-LIBSOIL_VERSION = 20080707
-LIBSOIL_SOURCE = soil.zip
-LIBSOIL_SITE = http://www.lonesock.net/files
-LIBSOIL_INSTALL_STAGING = YES
-LIBSOIL_DEPENDENCIES = libgl
-LIBSOIL_LICENSE = Public Domain, MIT
-LIBSOIL_LICENSE_FILES = src/stb_image_aug.c src/image_helper.c
-LIBSOIL_MAKEFILE = ../projects/makefile/alternate_Makefile.txt
-
-define LIBSOIL_EXTRACT_CMDS
-	$(UNZIP) -d $(@D) $(LIBSOIL_DL_DIR)/$(LIBSOIL_SOURCE)
-	mv $(@D)/Simple\ OpenGL\ Image\ Library/* $(@D)
-endef
-
-# gnu patch < v2.5.9 doesn't correctly handle spaces in file names,
-# and we want to patch the 'alternate Makefile.txt' file, so rename
-# the file (and patch the renamed file) for compatibility with older
-# distributions
-define REMOVE_SPACE_FROM_FILENAME
-	cd $(@D)/projects/makefile/ && \
-		mv "alternate Makefile.txt" alternate_Makefile.txt
-endef
-LIBSOIL_POST_EXTRACT_HOOKS += REMOVE_SPACE_FROM_FILENAME
-
-define LIBSOIL_BUILD_CMDS
-	$(MAKE) $(TARGET_CONFIGURE_OPTS) -f $(LIBSOIL_MAKEFILE) \
-		-C $(@D)/src
-endef
-
-define LIBSOIL_INSTALL_STAGING_CMDS
-	$(MAKE) $(TARGET_CONFIGURE_OPTS) -f $(LIBSOIL_MAKEFILE) \
-		DESTDIR=$(STAGING_DIR) install \
-		INSTALL=$(INSTALL) \
-		-C $(@D)/src
-endef
-
-define LIBSOIL_INSTALL_TARGET_CMDS
-	$(MAKE) $(TARGET_CONFIGURE_OPTS) -f $(LIBSOIL_MAKEFILE) \
-		DESTDIR=$(TARGET_DIR) install \
-		INSTALL=$(INSTALL) \
-		-C $(@D)/src
-endef
-
-$(eval $(generic-package))